BN_COPY(3)

NAME
BN_copy, BN_dup, BN_with_flags - copy BIGNUMs

SYNOPSIS
#include <openssl/bn.h>
BIGNUM *
BN_copy(BIGNUM *to, const BIGNUM *from);
BIGNUM *
BN_dup(const BIGNUM *from);
void
BN_with_flags(BIGNUM *dest, const BIGNUM *b, int flags);

DESCRIPTION
BN_copy() copies from to to.

BN_dup() creates a new BIGNUM containing the value from.

BN_with_flags() creates a temporary shallow copy of b in dest. It places significant restrictions on the copied data. Applications that do not adhere to these restrictions may encounter unexpected side effects or crashes. For that reason, use of this function is discouraged.

Any flags provided in flags will be set in dest in addition to any flags already set in b. For example, this can be used to create a temporary copy of a BIGNUM with the BN_FLG_CONSTTIME flag set for constant time operations.

The temporary copy in dest will share some internal state with b. For this reason, the following restrictions apply to the use of dest:

•   dest should be a newly allocated BIGNUM obtained via a call to BN_new(3). It should not have been used for other purposes or initialised in any way.

•   dest must only be used in "read-only" operations, i.e. typically those functions where the relevant parameter is declared "const".

•   dest must be used and freed before any further subsequent use of b.

RETURN VALUES
BN_copy() returns to on success or NULL on error. BN_dup() returns the new BIGNUM or NULL on error. The error codes can be obtained by ERR_get_error(3).

SEE ALSO
BN_new(3), BN_set_flags(3)

HISTORY
BN_copy() and BN_dup() first appeared in SSLeay 0.5.1 and have been available since OpenBSD 2.4.

BN_with_flags() first appeared in OpenSSL 0.9.7h and 0.9.8a and has been available since OpenBSD 4.0.